/*
   This program parses and then evaluates strings from Language-10.
*/

public class Example3
{
   public static void main(String[] args)
   {
      // Compare the result of this program with Example2.java and with
      // the equivalent programs in Scheme, ML, and Haskell..
      String expr = "( prog " +
                       "( begin " +
                           "( var x 1 ) " +
                           "( begin " +
                             "( var x 2 ) " +
                             "( var y x ) " +     // this y is different in Scheme
                             "( begin " +
                                "( var x y ) " +  // this y is different in Haskell
                                "( var f ( lambda z ( * x ( * y z ) ) ) ) " + // this y is different in ML
                                "( var y 3 ) " +
                                "( apply f y ) " +
                          ") ) ) )";

      // build the abstract syntax tree that represents the expression
      Tree ast = BuildTree.buildTree( expr );

      // print the original expression
      System.out.println( expr + "\n" );
      // pretty-print the abstract syntax tree
      System.out.println( PrettyPrinter3.prettyPrint( ast ) + "\n" );
      // print the infix version of the expression
      System.out.println( AST2infix.ast2infix( ast ) + "\n" );

      try
      {
         // evaluate the expression (interpret the AST)
         Value value = Evaluate.evaluate( ast );

         System.out.println( "result = " + value );
      }
      catch (EvalException e)
      {
         e.printStackTrace();
      }
   }//main

}//Example3