/*
   This program parses and then evaluates strings from Language-10.
*/

public class Example4
{
   public static void main(String[] args)
   {
      // Compare the results of these programs with the equivalent programs in Scheme, ML, and Haskell..
      String expr1 = "( prog " +
                        "( begin " +
                            "( var f ( lambda n 0 ) ) " +
                            "( begin " +
                              "( var f ( lambda n ( if ( = n 0 ) 1 ( * n ( apply f ( - n 1 ) ) ) ) ) ) " +
                              "( apply f 4 ) " +
                            ") ) )";

      String expr2 = "( prog " +
                        "( begin " +
                            "( var odd ( lambda n false ) ) " +
                            "( begin " +
                              "( var even ( lambda n ( if ( = n 0 ) true  ( apply  odd ( - n 1 ) ) ) ) ) " +
                              "( var odd  ( lambda n ( if ( = n 0 ) false ( apply even ( - n 1 ) ) ) ) ) " +
                              "( apply even 6 ) " +
                            ") ) )";
      String expr = expr1;

      // build the abstract syntax tree that represents the expression
      Tree ast = BuildTree.buildTree( expr );

      // print the original expression
      System.out.println( expr + "\n" );
      // pretty-print the abstract syntax tree
      System.out.println( PrettyPrinter3.prettyPrint( ast ) + "\n" );
      // print the infix version of the expression
      System.out.println( AST2infix.ast2infix( ast ) + "\n" );

      try
      {
         // evaluate the expression (interpret the AST)
         Value value = Evaluate.evaluate( ast );

         System.out.println( "result = " + value );
      }
      catch (EvalException e)
      {
         e.printStackTrace();
      }
   }//main

}//Example3