let
   val x = 10
   val y = x + 10
   val z = x + y
in
   x + y + z
end;


let
   val z = 3
   val x = if z  = 0 then 1 else y
   and y = if z <> 0 then 2 else x
in
   x + y + z
end;


(* the following kind of recursive definition is not allowed in ML *)
let
   val z = 3
   val rec x = if z  = 0 then 1 else y
       and y = if z <> 0 then 2 else x
in
   x + y + z
end;




let
   val y = 3
   val f = fn w => w*y
in
   f(y)
end;


let
   val y = 2
in
   let
      val f = fn w => w*y
      val y = 3
   in
      f(y)
   end
end;

(* Treat EVERY variable declaration as its own environment.
   That is, don't create an environment object when you enter
   the let-expression, create environment objects every time
   you evaluate a val-expression.
*)